<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsProduct_suite extends JPlugin
{
	function plgJoomsuite_content_fieldsProduct_suite( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'product_suite') return;
		global $mainframe;
		$document 	= &JFactory::getDocument();
		$user = &JFactory::getUser();

		$value = $obj->field_value;
		if($value != '')
		$value = unserialize($value);

		$out = '';

		$out .= JText::_('Suite discount').':
		<input type="text" name="fields['.$obj->id.'][discount]" value="'.(isset($value['discount']) ? $value['discount'] : '').'" size="3"
			id="fields'.$obj->id.'-discount" onkeyUp="formatFloat(this.id)"> %
		<br><br>
		<table id="productSuiteTable" border="0" cellpadding="2" cellspacing="0" width="80%">
			<tr class="sectiontableheader" bgcolor="#444444" style="color: #fff;">
				<td class="sectiontableheader" width="1px">#</td>
				<td class="sectiontableheader">'.JText::_('Product').'</td>
				<td class="sectiontableheader">'.JText::_('Category').'</td>
				<td class="sectiontableheader">'.JText::_('Type').'</td>
				<td class="sectiontableheader">'.JText::_('Client').'</td>
				<td class="sectiontableheader" width="10%">'.JText::_('Amount').'</td>
				<td class="sectiontableheader" width="10%">'.JText::_('Remove').'</td>
			</tr>';
		$ids = '';
		if(isset($value['items']))
		{
			$i = 1; $p = 0;
			$ids = array();
			foreach ($value['items'] as $k => $item)
			{
				$article = $this->getArticleInfo($item['id']);

				$out .= '
				<tbody id="productSuiteId'.$item['id'].'">
					<tr class="sectiontableentry'.($p + 1).'" valign="top">
						<td>'.$i.'. </td>
						<td>'.$article->title.'<input type="hidden" name="fields['.$obj->id.'][id][]" value="'.$item['id'].'"></td>
						<td>'.$article->category.'</td>
						<td>'.$article->type.'</td>
						<td>'.$article->client.'</td>
						<td><input type="text" name="fields['.$obj->id.'][amount][]" value="'.$item['amount'].'" 
							size="2" id="fields'.$obj->id.'-amount'.$k.'" onkeyup="formatInt(this.id)" class="inputbox"></td>
						<td align="center">
							<a href="javascript: void(0);" onclick="removeProductSuite(\'productSuiteId'.$item['id'].'\', \''.$item['id'].'\')">
							<img src="'.JURI::root().'plugins/joomsuite_content_fields/images/product_suite/remove.png" 
								title="'.JText::_('Remove').'" alt="'.JText::_('Remove').'" border="0">
							</a>
						</td>
					</tr>
				</tbody>';
				$i ++; $p = 1 - $p;
				$ids[] = $item['id'];
			}
			$ids = implode(',', $ids);
		}
		$out .= '
		</table>';

		$out .= ' <table><tr>
			<td>'.JText::_('Add products to suite').':</td>
			<td><input type="button" class="button" value="'.JText::_('Select').'" onclick="showProductSuiteBlock(\'suite-'.$obj->id.'\')"></td>
			</tr></table>';
		$section_id = $params->get('section_id');

		?>
<script language="javascript" type="text/javascript">
	    
	function formatFloat(id)
	{
		var cur = document.getElementById(id).value;
		reg = /[^\d\.]+/;
		cur = cur.replace(',', '.');
		cur = cur.replace('..', '.');
		cur = cur.replace(reg, '');
		document.getElementById(id).value = cur;
	}
	
	function formatInt(id)
	{
		var cur = document.getElementById(id).value;
		reg = /[^\d]+/;
		cur = cur.replace(reg, "");
		document.getElementById(id).value = cur;
	}

	var d = document;
	
	function showProductSuiteBlock(id)
	{
		var type = document.getElementById(id).style.display;
		if(type == 'block')
		document.getElementById(id).style.display = 'none';
		else
		{
			document.getElementById(id).style.display = 'block';
		}		
	}
	
	function selectProductsToSuite()
	{
		var num = document.getElementById('total').value;
		var ids = new Array();
		var k = 0;
		for (i = 0; i < num; i++)
		{
			if(document.getElementById('cb'+i).checked)
			{
				ids[k] = document.getElementById('cb'+i).value;
				k ++;
			}			
		}
		xajax_jsCallPlugin('joomsuite_content_fields', 'product_suite', 'xajax_jsGetProductSuite', ['<?php echo $obj->id;?>', ids, d.getElementById('suite_products').value]);
	}
	
	function removeProductSuite(id, val)
	{
		xajax_jsCallPlugin('joomsuite_content_fields', 'product_suite', 'xajax_jsRemoveProductSuite', [d.getElementById('suite_products').value, id, val, d.getElementById('section_id').value]);
	}
	 
	function checkProductsSuite()
	{
		var val = document.getElementById('checkAllSuite').value;
		var num = document.getElementById('total').value;
		for (i = 0; i < num; i++)
		{
			if(val == 1)
			{
				document.getElementById('cb'+i).checked = 'on';
				document.getElementById('checkAllSuite').value = '0';
			}
			else
			{
				document.getElementById('cb'+i).checked='';
				document.getElementById('checkAllSuite').value = '1';
			}
		}
	}

	function setSectionId(val)
	{
		d.getElementById('section_id').value = val;
		d.getElementById('page').value = 1;
		d.getElementById('limit_start').value = 0;
		callXajax();
	}

	function setLimit(val)
	{
		d.getElementById('limit').value = val;
		setPage(1);
	}
	
	function setPage(val)
	{	
		old = d.getElementById('page').value;
		if( d.getElementById('page' + old) != null ) {
    		d.getElementById('page' + old).innerHTML = old;
    		
    		d.getElementById('page').value = val;
    		d.getElementById('page' + val).innerHTML= '<b>' + val + '</b>';	
		}
		d.getElementById('limit_start').value = (val - 1) * d.getElementById('limit').value;
		
		callXajax();
	}
	
	function getOrderingId(val)
	{
		var id = '';
		switch(val)
		{
			case 'r.title': id = 'title'; break;
			case 'r.ctime': id = 'created'; break;
			case 'category': id = 'category'; break;
			case 'type': id = 'type'; break;
			case 'client': id = 'client'; break;
		}
		return id;
	}
	
	
	function setOrderby(val)
	{
		var id = getOrderingId(val);
		var old = getOrderingId(d.getElementById('order_by').value);
		d.getElementById(old + 'Sort').innerHTML = "";
		
		d.getElementById('order_by').value = val;
		var dir = d.getElementById('order_by_dir').value;
		dir = (dir == 'DESC') ? 'ASC' : 'DESC';
		d.getElementById('order_by_dir').value = dir;
		var image = '';
		if(dir == 'DESC')
		image = '<img src="<?php echo JURI::root(); ?>images/sort_desc.png" border="0">';
		else
		image = '<img src="<?php echo JURI::root(); ?>images/sort_asc.png" border="0">';
			
		d.getElementById(id + 'Sort').innerHTML = image;
		callXajax();
	}
	
	function callXajax()
	{
		var order_by = d.getElementById('order_by').value;
		var order_by_dir = d.getElementById('order_by_dir').value;
		var limit = d.getElementById('limit').value;
		var limit_start = d.getElementById('limit_start').value;
		var search = d.getElementById('product_suite_search').value;
		var section = d.getElementById('section_id').value;
		d.getElementById('productSuiteTableBody').innerHTML = '<tr><td colspan="7" align="center"><br><img src="<?php echo JURI::root(); ?>plugins/joomsuite_content_fields/images/product_suite/indicator.gif" border="0"></td></tr>';
		xajax_jsCallPlugin('joomsuite_content_fields', 'product_suite', 'xajax_jsGetProducts', ['<?php echo $obj->record_id; ?>', section, order_by, order_by_dir, search, limit, limit_start, false]);
	}

	</script>
<style>
.html {
	background: #FFFFFF;
	padding: 10px;
}

.pages:hover {
	cursor: hand;
}

.titleOrdering {
	color: #FFFFFF;
}
</style>
		<?php

		$total = $this->getArticles($obj->record_id, $user->id, $section_id, 'total', $params->get('rows_limit', 5));
		$all = $this->getArticles($obj->record_id, $user->id, $section_id, 'total', 'all');
		$pages = ceil($all / $params->get('rows_limit', 5));

		$pageNav = '';
		if($pages > 1)
		{
			for ($i = 1; $i <= $pages; $i ++)
			{
				$pageNav .= '<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$i.'\')" class="pages">'.($i == 1 ? '<b>'.$i.'</b>' : $i ).'</a> ';
			}
			$pageNav .= '<br><br>';
		}
		$admin = false;
		if(JRequest::getVar('controller') == 'record')
		$admin = true;
		if(JRequest::getVar('controller') == 'article' && JRequest::getVar('layout') == 'form' && in_array($user->gid , array('24', '25')))
		$admin = true;


		$out .= '
		<div id="suite-'.$obj->id.'" style="display: none;">
			<div id="suite-'.$obj->id.'-content" class="small">
				<table width="100%">
					<tr>
					<td align="left" nowrap width="30%">
						'.JText::_('Filter').': <input type="text" id="product_suite_search" size="15" class="inputbox" value="">
						<input type="button" value="'.JText::_('Go').'" class="button" onclick="if(this.value != \'\') {setPage(1);}">
						<input type="button" value="'.JText::_('Reset').'" class="button" onclick="d.getElementById(\'product_suite_search\').value = \'\';setPage(1);">
					</td>	
					<td nowrap id="selectSection">
						'.(($ids == '' && $admin) ? JText::_('Filter by section').': '.$this->getSections($section_id) : '') .'
					</td>
					</tr>
				</table>
				<table border="0" cellpadding="2" cellspacing="0" width="100%">
					<tr class="sectiontableheader"'.($mainframe->isAdmin() ? ' bgcolor="#444444" style="color: #fff;"' : '').'>
						<td class="sectiontableheader" width="1px">#</td>
						<td class="sectiontableheader" width="1px">
							<input type="checkbox" id="checkAllSuite" onclick="checkProductsSuite();"
							value="1" name="checkAllSuite">
						</td>
						<td class="sectiontableheader">
							<a href="javascript: void(0);" onclick="setOrderby(\'r.title\')" style="color: #fff;">'.JText::_('Title').'</a> 
								<span id="titleSort"></span>
						</td>
						<td class="sectiontableheader" width="10%">
							<a href="javascript: void(0);" onclick="setOrderby(\'r.ctime\')" style="color: #fff;">'.JText::_('Created').'</a> 
								<span id="createdSort"><img src="'.JURI::root().'images/sort_desc.png" border="0"></span>
						</td>
						<td class="sectiontableheader" width="10%">
							<a href="javascript: void(0);" onclick="setOrderby(\'category\')" style="color: #fff;">'.JText::_('Category').'</a> 
								<span id="categorySort"></span>
						</td>
						<td class="sectiontableheader" width="10%">
							<a href="javascript: void(0);" onclick="setOrderby(\'type\')" style="color: #fff;">'.JText::_('Type').'</a> 
								<span id="typeSort"></span>
						</td>
						<td class="sectiontableheader" width="10%">
							<a href="javascript: void(0);" onclick="setOrderby(\'client\')" style="color: #fff;">'.JText::_('Client').'</a> 
								<span id="clientSort"></span>
						</td>
					</tr>
					<tbody id="productSuiteTableBody">
					'.$this->getArticles($obj->record_id, $user->id, $section_id, false, $params->get('rows_limit', 5)).'
					</tbody>
				</table>
				<div id="pageNav" style="text-align: center; padding: 2px;">
					'.$pageNav.'
				</div>
				<div align="center">'.JText::_('Display').'
					<select id="limits" onchange="setLimit(this.value)" name="limits">
						<option value="5">5</option>
						<option value="10">10</option>
						<option value="15">15</option>
						<option value="20">20</option>
						<option value="25">25</option>
						<option value="30">30</option>
						<option value="50">50</option>
						<option value="100">100</option>
						<option value="all">all</option>
					</select>
				</div>
				<input type="hidden" id="section_id" value="'.$section_id.'" >
				<input type="hidden" id="order_by" value="r.ctime" >
				<input type="hidden" id="order_by_dir" value="DESC" >
				<input type="hidden" id="limit_start" value="0" >
				<input type="hidden" id="limit" value="'.$params->get('rows_limit', 5).'" />				
				<input type="hidden" id="total" value="'.$total.'" />		
				<input type="hidden" id="page" value="1" />				
				<input type="hidden" id="suite_products" value="'.$ids.'" />
				<p align="left">
					<input type="button" class="button" value="'.JText::_('Select products').'" onclick="selectProductsToSuite();">
				</p>				
			</div>
		</div>';
		echo $out;

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'product_suite') return;
		if(!$value) return;
		$new_value = array();
		foreach ($value['id'] as $k => $id)
		{
			$new_value['items'][$k]['id'] = $id;
			$new_value['items'][$k]['amount'] = $value['amount'][$k];
		}
		$new_value['discount'] = $value['discount'];
		$value = serialize($new_value);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'product_suite') return;
		if( !$field->field_value || $field->field_value == '') return;
		
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;	

		$db = & JFactory::getDBO();
		$dispatcher =& JDispatcher::getInstance();

		$value = unserialize($field->field_value);
		$option = JRequest::getVar('option');
		$view = JRequest::getVar('view');
		$controller = JRequest::getVar('controller');
		$suite = array();
		$articles = array();
		if(!isset($value['items'])) return;

		foreach ($value['items'] as $k => $item)
		{
			$article = $this->getArticleInfo($item['id']);
			$catid = ResHelper::getArticleSection($item['id']);
			$article->link = 'index.php?option=com_resource&controller=article&article='.$item['id'].'&category_id='.$catid.'&Itemid='.JRequest::getInt('Itemid');
			$suite[] = $article;
			$article->price = false;
			if($params->get('show_price', 0))
			{
				JPluginHelper::importPlugin('joomsuite_content_fields', 'price');
				$price = 0;
				$dispatcher->trigger('onGetItemPrice', array (&$price, $item['id'], $item['amount'], 'core', true, true));

				$article->price = $price ;
			}
			$article->amount = $item['amount'];
			$articles[] = $article;
		}
		if($value['discount'])
		{
			$out .= '
			<style>';
			if($params->get('discount_img') != '-1')
			{
				$out .= '
			.productSuiteDiscount {
					background: url(\''.JURI::root().'plugins/joomsuite_content_fields/images/product_suite/discount/'.$params->get('discount_img').'\');
					background-repeat: no-repeat;					
					width: 100px;
					height: 98px;
					padding-top: 2px;
					color: #ffffff;
					font-size: 22px;
					font-weight: bold;
					text-align: center;
					vertical-align: middle;
					line-height: 20px;
					}
				';
			}
			$out .= '
			.productSuiteDiscountAlert {
					border: 1px solid #ff0000;
					vertical-align: middle;					
					padding: 5px;
					}
			</style>
			<table class="productSuiteDiscountAlert">
				<tr>
					<td>				
						<h2>'.$params->get('discount_alert').'
					';
			if($params->get('discount_img') != '-1')
			{
				$out .= '
						</h2>
					</td>
					<td class="productSuiteDiscount" align="center">
						'.$value['discount'].'% <br>'.JText::_('off').'
					</td>';
			}
			else
			$out .= $value['discount'].'% '.JText::_('off').'</h2></td>';
			$out .= '
				</tr>
			</table>';
		}
		$out .= '<p>'.JText::_('This product suite contains the following items').':</p>';
		
		if($option == 'com_resource' && $controller == 'article')
		{
			switch ($params->get('in_full', 'enumerated'))
			{
				case 'comma':
					$print = array();
					foreach ($articles as $k => $item)
					{
						if($params->get('linked_title', 1))
						$print[$k] = JHTML::link($item->link, $item->title, 'target="_blank"');
						else
						$print[$k] = $item->title;
						$print[$k] .= ': '.$item->amount.' '.(($item->amount == 1 ) ? JText::_('item') : JText::_('items'));
						if($params->get('show_price', 0))
						$print[$k] .= '<span class="small"> ('.$item->price.' '.JText::_('per 1 item').')</span>';
					}
					$out .= implode(', ', $print);
					break;
				case 'enumerated':
					$out .= '<ol>';
					foreach ($articles as $k => $item)
					{
						$out .= '<li>';
						if($params->get('linked_title', 1))
						$out .= JHTML::link($item->link, $item->title, 'target="_blank"');
						else
						$out .= $item->title;
						$out .= ': '.$item->amount.' '.(($item->amount == 1 ) ? JText::_('item') : JText::_('items'));
						if($params->get('show_price', 0))
						$out .= '<span class="small"> ('.$item->price.' '.JText::_('per 1 item').')</span>';
						$out .= '</li>';
					}
					$out .= '</ol>';
					break;
				case 'as_intro':
					$out .= $this->getItemsList($articles, $params, $category);
					break;
			}
		}
		else
		{
			switch ($params->get('in_intro', 'enumerated'))
			{
				case 'comma':
					$print = array();
					foreach ($articles as $k => $item)
					{
						if($params->get('linked_title', 1))
						$print[$k] = JHTML::link($item->link, $item->title, 'target="_blank"');
						else
						$print[$k] = $item->title;
						$print[$k] .= ': '.$item->amount.' '.(($item->amount == 1 ) ? JText::_('item') : JText::_('items'));
						if($params->get('show_price', 0))
						$print[$k] .= '<span class="small"> ('.$item->price.' '.JText::_('per 1 item').')</span>';
					}
					$out .= implode(', ', $print);
					break;
				case 'enumerated':
					$out .= '<ol>';
					foreach ($articles as $k => $item)
					{
						$out .= '<li>';
						if($params->get('linked_title', 1))
						$out .= JHTML::link($item->link, $item->title, 'target="_blank"');
						else
						$out .= $item->title;
						$out .= ': '.$item->amount.' '.(($item->amount == 1 ) ? JText::_('item') : JText::_('items'));
						if($params->get('show_price', 0))
						$out .= '<span class="small"> ('.$item->price.' '.JText::_('per 1 item').')</span>';
						$out .= '</li>';
					}
					$out .= '</ol>';
					break;
			}
		}

	}

	function getArticles($current, $uid, $section_id, $return = false, $limit, $limit_start = 0, $search = '', $order_by = 'r.ctime', $order_by_dir = 'DESC', $filters = false)
	{
		$db = & JFactory::getDBO();
		
		$cats = ResHelper::getCategoryChildrenIds($section_id);

		$sql = "SELECT r.id, r.title, r.ctime, cat.name as category, t.name as type, r.client
		FROM #__js_res_record AS r 
		JOIN #__js_res_record_category AS rcat ON rcat.record_id = r.id
		JOIN #__js_res_category AS cat ON cat.id = rcat.catid
		JOIN #__js_res_types AS t ON t.id = r.type_id
		WHERE ";
		$where[] = " r.user_id = '$uid' ";
		$where[] = " cat.id IN ({$cats}) ";
		if($current)
		{
			$where[] = " r.id != '$current' ";
		}

		if($search != '')
		$where[] = " r.title LIKE '%$search%' ";
		$sql .= implode(' AND ', $where);

		$sql .= " ORDER BY $order_by $order_by_dir";

		if($limit != 'all')
		$sql .= " LIMIT $limit_start, $limit";

		$db->setQuery($sql); // echo $db->_sql.'<br><br>';
		$list = $db->loadObjectList();
		if(!$list) return;
		if($return == 'total')
		return count($list);

		jimport('joomla.utilities.date');
		$out = '';
		$k = 0; $i = $limit_start + 1;
		foreach ($list as $p => $row)
		{
			$ctime = new JDate( $row->ctime);
			$out .= '
			<tr class="sectiontableentry'.($k + 1).'" valign="top">
				<td>'.$i.'</td>
				<td><input type="checkbox" id="cb'.$p.'" name="prSuite[]" value="'.$row->id.'" /></td>
				<td>'.$row->title.'</td>
				<td nowrap><span class="createdate">'.$ctime->toFormat('%d %b %Y').'</span></td>
				<td nowrap>'.$row->category.'</td>
				<td nowrap>'.$row->type.'</td>
				<td nowrap>'.$row->client.'</td>
			</tr>
			';
			$k = 1 - $k;
			$i++;
		}
		return $out;
	}

	function xajax_jsGetProducts(&$objResponse, $current, $section_id, $order_by, $order_by_dir, $search, $limit, $limit_start, $filters = false)
	{
		// $objResponse->alert("order = $order_by, $order_by_dir; search = $search; limit = $limit, limit_st = $limit_start, $filters");
		$user = &JFactory::getUser();

		$list = $this->getArticles($current, $user->id, $section_id, false, $limit, $limit_start, $search, $order_by, $order_by_dir, $filters);

		$total = $this->getArticles($current, $user->id, $section_id, 'total', $limit, $limit_start, $search, $order_by, $order_by_dir, $filters);

		$all = $this->getArticles($current, $user->id, $section_id, 'total', 'all', $limit_start, $search, $order_by, $order_by_dir, $filters);

		//$objResponse->alert("total = $total && all = $all");

		$objResponse->assign('productSuiteTableBody', 'innerHTML', $list);

		$pages = ceil($all / $limit);

		$pageNav = '';
		if($pages > 1)
		{
			for ($i = 1; $i <= $pages; $i ++)
			{
				$pageNav .= '<a href="javascript: void(0);" id="page'.$i.'" onclick="setPage(\''.$i.'\')" class="pages">'.$i .'</a> ';
			}
			$pageNav .= '<br><br>';
		}
		$objResponse->assign('pageNav', 'innerHTML', $pageNav);
		$objResponse->assign('total', 'value', $total);

		$js = "
		var val = d.getElementById('page').value;
		d.getElementById('page' + val).innerHTML= '<b>' + val + '</b>';	
			
		d.getElementById('limit_start').value = (val - 1) * d.getElementById('limit').value;
		";
		$objResponse->script($js);

		return $objResponse;

	}

	function xajax_jsGetProductSuite(&$objResponse, $field_id, $ids, $products)
	{
		if(!is_array($ids)) settype($ids, 'array');
		/*$session = & JFactory::getSession();
		 $suite = $session->get('my_suite');
		 if(count($suite))
		 {
		 array();
		 }*/
		$out = '';
		$amount = 0;
		$items = array();
		if($products != '')
		{
			$items[] = $products;
			$products = explode(',', $products);
			$amount = count($products);
		}

		$i = $amount + 1;
		foreach ($ids as $id)
		{
			if($products == '' || (count($products) && !in_array($id, $products)) )
			{
				$article = $this->getArticleInfo($id);
				$out .= '
				<tbody id="productSuiteId'.$id.'">
					<tr>
						<td>'.$i.'. </td>
						<td>'.$article->title.'<input type="hidden" name="fields['.$field_id.'][id][]" value="'.$id.'"></td>
						<td>'.$article->category.'</td>
						<td>'.$article->type.'</td>
						<td>'.$article->client.'</td>
						<td><input type="text" name="fields['.$field_id.'][amount][]" value="1" size="2" 
							id="fields'.$field_id.'-amount'.$i.'" onkeyup="formatInt(this.id)" class="inputbox"></td>
						<td align="center">
							<a href="javascript: void(0);" onclick="removeProductSuite(\'productSuiteId'.$id.'\', \''.$id.'\')">
							<img src="'.JURI::root().'plugins/joomsuite_content_fields/images/product_suite/remove.png" 
								title="'.JText::_('Remove').'" alt="'.JText::_('Remove').'" border="0">
							</a>
						</td>
					</tr>
				</tbody>
				';
				$i++;
				$items[] = $id;
			}
		}
		$products = implode(',', $items);
		$amount = count(explode(',', $products));
		$objResponse->append('productSuiteTable', 'innerHTML', $out);
		$objResponse->assign('suite_products', 'value', $products );
		$objResponse->assign('suite-'.$field_id, 'style.display', 'none' );
		if($products != '')
		$objResponse->assign('selectSection', 'innerHTML', '' );

		return $objResponse;
	}


	function xajax_jsremoveProductSuite(&$objResponse, $products, $element, $id, $section_id)
	{
		$products = explode(',', $products);
		$items = array();
		foreach ($products as $val)
		{
			if($val != $id)
			$items[] = $val;
		}
		$amount = count($items);
		$products = implode(',', $items);
		$objResponse->remove($element);
		$objResponse->assign('suite_products', 'value', $products );
		if($products == '')
		$objResponse->assign('selectSection', 'innerHTML', JText::_('Filter by section').': '.$this->getSections($section_id) );
		return $objResponse;
	}


	function getArticleInfo($id)
	{
		$db = & JFactory::getDBO();
		$sql = "SELECT r.*, t.id as type_id, t.name as type, cat.name as category, cat.id as catid, cu.name as user_category
		FROM #__js_res_record AS r
		JOIN #__js_res_record_category AS rcat ON rcat.record_id = r.id
		JOIN #__js_res_category AS cat ON cat.id = rcat.catid
		LEFT JOIN #__js_res_category_user AS cu ON cu.id = r.ucatid
		JOIN #__js_res_types AS t ON t.id = r.type_id
		WHERE r.id = '$id'";
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function getItemsList($items, $plg_params, $categoty_id)
	{
		global $mainframe;
		jimport ('joomla.utilities.date');

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();

		require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'view.html.php');
		require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
		require_once(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'helpers'.DS.'helper.php');
		$document = &JFactory::getDocument();
		$db 	  = &JFactory::getDBO();
		$document->addScript( JURI::root().'components/com_resource/helpers/script.js' );
		$document->addScript( JURI::root().'/components/com_resource/helpers/felixrating.js' );
		$me = &JFactory::getUser();
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');

		$model = &JModel::getInstance('List','ResModel');

		$limit = 99999;
		$sectionId = $categoty_id;//ResHelper::getArticleSection($items[0]->id);

		$model->setState('limit', $limit);
		$params = new JParameter('');
		$params->set('client', 'module');
		JRequest::setVar('all', 1);
		JRequest::setVar('category_id', $sectionId);
		JRequest::setVar('view', 'list');


		$document	= &JFactory::getDocument();
		$uri 		= &JFactory::getURI();
		$pathway	= &$mainframe->getPathway();
		$itemid		= JRequest::getInt('Itemid');

		$params->set('section_id', $sectionId);
		$sparams	=  ResHelper::initListParams($sectionId);
		$sparams->set('list_clients', 0);
		$params->merge($sparams);

		$document->addScript(JURI::root().'includes/js/joomla.javascript.js');


		switch ($params->get('filters_mode', 1))
		{
			case 3:
			case 1:
				$fname_order = "filter_order{$itemid}{$sectionId}";
				$fname_order_dir =  "filter_order_dir{$itemid}{$sectionId}";
				break;
			case 2:
				$fname_order = "filter_order{$itemid}";
				$fname_order_dir =  "filter_order_dir{$itemid}";
				break;
		}

		$order = explode(" ", $params->get('orderby', 'r.ctime DESC'));
		$model->setState($fname_order, $order[0]);
		$model->setState($fname_order_dir, $order[1]);

		if (count($items)<1)
		{
			return JText::_('No records yet there. Be first who add record!');
		}

		$category = $model->getCategory($params->get('section_id', $sectionId));
		$section = $model->getCategory($sectionId);
		$params->set("generate_user_menu", 0);
		
		MRRecordHelper::prepareItems($items, $params, $category);

		$columns = array();
		$nfields = array();
		$ifields = array();
		$cols = array();
		$cols_additional = array();
		foreach ($items AS $key => $item)
		{
			$fields[$item->id] = $model->getFields($item->id);
			if(is_array($fields[$item->id]))
			{
				foreach ($fields[$item->id] AS $k => $field)
				{
					$columns[$field->ordering]['title'] = $field->title;
					$columns[$field->ordering]['id'] = $field->fid;

					$columns[$field->ordering]['params'] = new JParameter( $field->params );

					$get = false;
					$field_params = new JParameter($field->params);
					$dispatcher =& JDispatcher::getInstance();
					/*if($field->type != 'product_suite')
					 {*/
					JPluginHelper::importPlugin( 'joomsuite_content_fields', $field->type );
					$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $field, &$item, $categoty_id ) );
					//}
					if($get)
					{
					    $cparams = ResHelper::initListParams($category->id);
						if(!$model->_fieldSubscriptionAccess($get, $field_params, $cparams, $item->user_id))
						{
							$model->_fieldGroupAccess($get, $field_params);
						}
						if($get)
						{
							$ifields[$key][$field->title] = $get;
							$ifields[$key][$field->fid] = $get;

						}

					}
					$nfields[$item->id][$field->fid] = $field;
					$nfields[$item->id][$field->fid]->result = $get;
					//					if($get) $ifields[$key][$field->title] = $get;
				}
			}
		}
		$fields = $nfields;
		if(count($columns) > 0)
		{
			ksort($columns);
			foreach ($columns AS $sort => $data)
			{
				$cols[$data['title']] = $data['id'];
				$cols_additional[$data['title']]['params'] = $data['params'];
			}
		}

		$tpl_array = explode(",", $plg_params->get('tmpl_list'));
		$params->set('tmpl_list', $tpl_array[0]);
		$tmpl_ini = JFile::read(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$plg_params->get('tmpl_list').'.ini');
		$tmpl_xml = JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$plg_params->get('tmpl_list').'.xml';
		$tmpl_params = new JParameter($tmpl_ini, $tmpl_xml);
		$params->merge($tmpl_params);

		$this->params = $params;
		$this->cols = $cols;
		$this->fields = $fields;
		$this->ifields = $ifields;
		$this->items = $items;
		$this->columns = $columns;
		$this->section = $section;
		$this->category = $category;
		$this->cols_additional = $cols_additional;
		$this->user = $me;
		$this->mmodel = $model;

		ob_start();

		include JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'views'.DS.'list'.DS.'tmpl'.DS.'default_subtmpl_'.$plg_params->get('tmpl_list').'.php';

		$contents = ob_get_contents();
		ob_end_clean();

		//JRequest::setVar('view', 'group');
		return $contents;
	}
	function getFieldValue($field, $user)
	{
		$model = &JModel::getInstance('List','ResModel');
		return $model->getFieldValue($field, $user);
	}

	function getSections($value)
	{
		$db	= & JFactory::getDBO();

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
		$sql = "SELECT id, name FROM #__js_res_category WHERE parent = '0' AND published = '1' ORDER BY ordering, id";
		$db->setQuery($sql);
		$res = $db->loadObjectList();
		$options = array();
		if(count($res) > 0)
		{
			foreach ($res as $val)
			{
				$CP = ResHelper::getSectionParams($val->id);
				if($CP->get('comm_enabled'))
				$options[] = JHTML::_('select.option', $val->id, $val->name);
			}
		}
		if(!count($options))
		return;
		$html	= JHTML::_('select.genericlist',  $options, "section", 'class="inputbox" onchange="setSectionId(this.value);"', 'value', 'text', $value);

		return $html;
	}

}
?>